/** @file
 * VirtualBox API class wrapper header for IDisplaySourceBitmap.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/*
 * Copyright (C) 2010-2020 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#ifndef DisplaySourceBitmapWrap_H_
#define DisplaySourceBitmapWrap_H_
#ifndef RT_WITHOUT_PRAGMA_ONCE
# pragma once
#endif

#include "VirtualBoxBase.h"
#include "Wrapper.h"

class ATL_NO_VTABLE DisplaySourceBitmapWrap
    : public VirtualBoxBase
    , VBOX_SCRIPTABLE_IMPL(IDisplaySourceBitmap)
{
    Q_OBJECT

public:
    VIRTUALBOXBASE_ADD_ERRORINFO_SUPPORT(DisplaySourceBitmapWrap, IDisplaySourceBitmap)
    DECLARE_NOT_AGGREGATABLE(DisplaySourceBitmapWrap)
    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(DisplaySourceBitmapWrap)
        COM_INTERFACE_ENTRY(ISupportErrorInfo)
        COM_INTERFACE_ENTRY(IDisplaySourceBitmap)
        COM_INTERFACE_ENTRY2(IDispatch, IDisplaySourceBitmap)
        VBOX_TWEAK_INTERFACE_ENTRY(IDisplaySourceBitmap)
    END_COM_MAP()

    DECLARE_EMPTY_CTOR_DTOR(DisplaySourceBitmapWrap)

    /** @name Public IDisplaySourceBitmap properties
     * @{ */
    STDMETHOD(COMGETTER(ScreenId))(ULONG *aScreenId);
    /** @} */

    /** @name Public IDisplaySourceBitmap methods
     * @{ */
    STDMETHOD(QueryBitmapInfo)(BYTE **aAddress,
                               ULONG *aWidth,
                               ULONG *aHeight,
                               ULONG *aBitsPerPixel,
                               ULONG *aBytesPerLine,
                               BitmapFormat_T *aBitmapFormat);
    /** @} */

private:
    /** @name Wrapped IDisplaySourceBitmap properties
     * @{ */
    virtual HRESULT getScreenId(ULONG *aScreenId) = 0;
    /** @} */

    /** @name Wrapped IDisplaySourceBitmap methods
     * @{ */
    virtual HRESULT queryBitmapInfo(BYTE **aAddress,
                                    ULONG *aWidth,
                                    ULONG *aHeight,
                                    ULONG *aBitsPerPixel,
                                    ULONG *aBytesPerLine,
                                    BitmapFormat_T *aBitmapFormat) = 0;
    /** @} */

private:
    DECLARE_CLS_COPY_CTOR_ASSIGN_NOOP(DisplaySourceBitmapWrap); /* Shuts up MSC warning C4625. */

};

#endif // !DisplaySourceBitmapWrap_H_
